'use strict';

exports.__esModule = true;
exports['default'] = thunkMiddleware;

function thunkMiddleware(getState) {
  return function (next) {
    var recurse = function recurse(action) {
      return typeof action === 'function' ? action(recurse, getState) : next(action);
    };

    return recurse;
  };
}

module.exports = exports['default'];